Subject: Re: Problems with using SelectOnRelease

From: Mikhael Goikhman <[email-masked]>
Date: Sat, 1 Mar 2003 16:33:11 +0000

On 28 Feb 2003 16:25:28 +0100, Dominik Vogt wrote:
> 
> On Fri, Feb 28, 2003 at 02:42:59PM +0000, Mikhael Goikhman wrote:
> > 
> > Actually, if we speak about the whole idea, I don't think it is very
> > usable as it is now. It is not very easy to setup, because it requires
> > knowing the modifier keysym. Additionally,
> > only one modifier like Meta_L works, not any Alt (there are two).
> 
> Um, your keyboard has two Alt keys?  I have never seen such a
> keyboard.

Well, I never seen a keyboard with only one Alt, thinking about this
German has more letters than latin, so this is probably what captured the
right Alt.

> > And if a binding does not include the
> > modifier configured in MenuStyle SelectOnRelease, this unrelated modifier
> > still works like Enter, this is a bad side effect.
> > 
> > I think that instead of SelectOnRelease it would be much better to
> > have SelectOnFullRelease option (the exact name could be shorter).
> > The default is !SelectOnFullRelease. So the following bindings work
> > without auto-release:
> > 
> >   Key Tab A CS WindowList
> >   Key F1  A CS Menu FvwmMenuRoot
> > 
> > and the following select an item when both Ctrl and Shift are released:
> > 
> >   Key Tab A CS WindowList SelectOnFullRelease
> >   Key F1  A CS Menu FvwmMenuRoot SelectOnFullRelease
> > 
> > Here any left/right Ctrl and Shift would work, not just one Ctrl_L.
> > I would like not to have any MenuStyle options related to auto-release,
> > because it is pretty trivial to set/unset this per a binding,
> > but MenuStyle is not an issue here.
> > 
> > This requires passing all modifiers that the menu was called with to that
> > menu, the auto-release is processed when all original modifiers are not
> > pressed anymore. I hope it is not a big problem to pass the modifiers.
> > 
> > I think it would be more convinient for a user.
> > What do you think?
> 
> I don't know, I think this is overkill.  The typical user wants
> one of two things:  either use the default as it is or turn off
> SelectOnRelease.  The case that she releases Alt first and still
> holds down the tab key is irrelevant in my eyes.  Wh do not have
> to care so much about redifining the key to trigger selection.  A
> clear description of how to remove the binding should be enough.
> 
> In any case, I can't easily think of a reliable method to check
> whether all keys are released or not.  What about state toggling
> keys like num-lock?

Strange you think it is overkill, for me it is much simplier and clean
than SelectOnRelease. By SelectOnFullRelease I mean the release of all
modifiers, i.e. left or right "Alt" in our case, not "Tab". I even think
the original modifiers should not be really passed to the menu code; if
IgnoreModifiers is global, a menu knows itself when no modifiers are
pressed anymore.

Regards,
Mikhael.
--
Visit the official FVWM web page at <URL:http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm-workers" in the
body of a message to [email-masked].
To report problems, send mail to [email-masked]

---

From: [email-masked]
Date: Sun, 2 Mar 2003 22:48:01 +0100

> German has more letters than latin, so this is probably what captured the

I have worked probably on more different keyboards with US layout
than with German layout, and thy all had an "Alt Gr" key (usually
directly right of the space bar).  Well, of course I do not recall
what was printed on the keys, but they definitely worked like the
typical "Alt Gr" key.  Funny.  

> IgnoreModifiers is global, a menu knows itself when no modifiers are

It's only simpler if you do indeed use a *modifier*.  For
non-modifier key you have to call XQueryKeymap and scan through
the key vector for for relevant set bits.

Bye

Dominik ^_^  ^_^

 --
Dominik Vogt, [email-masked]
Reply-To: [email-masked]
--
Visit the official FVWM web page at <URL:http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm-workers" in the
body of a message to [email-masked].
To report problems, send mail to [email-masked]

---

From: Mikhael Goikhman <[email-masked]>
Date: Mon, 3 Mar 2003 02:31:29 +0000

> > On 28 Feb 2003 16:25:28 +0100, Dominik Vogt wrote:

[SelectOnFull[Modifier]Release suggestion skipped]

> the key vector for for relevant set bits.

It only makes sence to do something on a modifier release. Doing anything
on a non-modifier release is simply too confusing and can't work, because
a user can't navigate a menu if a non-modifier is still pressed.

Regards,
Mikhael.

---

From: Dominik Vogt <[email-masked]>
Date: Mon, 3 Mar 2003 10:41:07 +0100

On Mon, Mar 03, 2003 at 02:31:29AM +0000, Mikhael Goikhman wrote:
> on a non-modifier release is simply too confusing and can't work,

I can think of at least two uses:

 1) A kind of randomizer with "SelectOnRelease (crsr-down) key".
    Open your xlock menu, press cursor down and select a more or
    less random item when you release the key.

 2) An alternate "select" key.  Open the menu normally and mark an
    item, then press e.g. F1 to trigger.

> because

That depends on the key.

Anyway, I don't really care too much about this feature.

Bye

Dominik ^_^  ^_^